

var var_requestCount=0;

// provide a simulation of the pre-firefox 3 SOAP API
var soapy =
{
	installed: true,
	// PUBLIC METHODS
	SOAPCall: function()
	// DESCRIPTION: SOAP Call object - emulates pre-Firefox3 API
	{
		// PUBLIC PROPERTIES
		
		this.parameters = {};
		
		this.transportURI = "http://example.tld/rpc";
		
		this.actionURI = "uri:XULadmin";
		
		this.version = "1.0";
		
		this.method = "default";
		
		this.method_namespace_uri = null;
		
		this.timeout = 60;
		
		this.body = null;
		
		this.encoding = null;
		
		this.header = null;
		
		this.message = null;
		
		this.envelope = new soapy.SOAPEnvelope();
		
		// PUBLIC METHODS
		
		this.QueryInterface = function()
		{
			// NOT IMPLEMENTED
			// METHOD: DESCRIPTION
		}
		
		this.getHeaderBlocks = function()
		{
			// NOT IMPLEMENTED
			// METHOD: DESCRIPTION
		}
		
		this.Parameters = function()
		{
			// NOT IMPLEMENTED
			// METHOD: DESCRIPTION
		}
		
		this.invoke = function()
		{
			// NOT IMPLEMENTED
			// METHOD: DESCRIPTION: synchronous SOAP call 
			// note: this function will probably not be implemented
			
			return false;
			
			// but should return a SOAPResponse object really
		}
		
		this.asyncInvoke = function(callback_function)
		{
			// METHOD: DESCRIPTION: asynchronous SOAP call
			// make XMLHTTPRequest and assign a callback function
			
			// return nothing: run callback function on reply - callback function
			// has to provide 3 parameters - response (SOAPResponse, soapcall object - its own, 
			// error code -> != 0 -> error)
			
//			alert('callback_function=' + callback_function);
			
			soapy.AJAXCall(this, callback_function) 
		}
		
		this.encode = function(ver, my_method, namespace_uri, length_headers, headers, objects_length, array_of_objects)
		{
			// METHOD: encode an array of SOAPParameter objects to the envelope
			// METHOD: DESCRIPTION: encode stuff to the envelope
			
			// should provide: soap_version, method_name, object_uri, headers_length, headers
			//		params_length, params
			// soapCall.encode(0, method, "urn:GoogleSearch", 0, null, params.length, params);
			
			try
			{
				
				var mymethod = document.createElementNS(namespace_uri, my_method);
				// mymethod.setAttribute("xmlns", namespace_uri);
				
				for (i = 0; i < array_of_objects.length; i++)
				{
					
					mymethod.appendChild(array_of_objects[i].e4x);
				}
				
				body = this.envelope.getElementsByTagName('env:Body')[0];	
				body.appendChild(mymethod);
				
				this.method = my_method;
				this.actionURI = namespace_uri;
				
			}catch(e){alert(e)}
			
		}
		
	},

	// PUBLIC OBJECTS

	SOAPParameter: function(parameter_value_or_object,parameter_name)
	{
		// DESCRIPTION: a SOAP Parameter
		
		try {

		value1 = parameter_value_or_object;

		var datatype = "xs:string";

		if (value1 == parseInt(value1))
		{
			datatype = "xs:int";
		}

		this.e4x = document.createElementNS("", parameter_name);
		
		this.e4x.setAttribute("xsi:type", datatype);

		mydata = document.createTextNode(value1);

		this.e4x.appendChild(mydata);

		this.value = value1;

		this.name = parameter_name;
		
		} catch(e){alert(e)}	
	},

	SOAPResponse: function (xml_object)
	{
		// properties: 
		
		this.method = null;
		this.version = null;
		
		this.body = xml_object.getElementsByTagName("SOAP-ENV:Body")[0];
		
		this.header = xml_object.getElementsByTagName("SOAP-ENV:Header")[0];
		
		this.envelope = xml_object.getElementsByTagName("SOAP-ENV:Envelope")[0];
	},

	SOAPFault: function(faultcode, faultstring)
	{
		// properties:
		
		this.faultCode = null;
		this.faultString = null;
		this.faultNamespaceURI = null;
		this.element = null;
		this.detail = null;
		
		var parser = new DOMParser();
		
		this.xmldom = new soapy.SOAPEnvelope();
		
		var body = this.xmldom.getElementsByTagName('env:Body')[0];
		
		var stringy = new XMLSerializer().serializeToString(this.xmldom);
		
		var my_fault = document.createElement('env:Fault');
		var my_faultcode = document.createElement('faultcode');
		var my_faultstring = document.createElement('faultstring');
		var my_detail = document.createElement('detail');
		
		var my_faultcode_value = document.createTextNode(faultcode);
		var my_faultstring_value = document.createTextNode(faultstring);
		
		my_faultcode.appendChild(my_faultcode_value);
		my_faultstring.appendChild(my_faultstring_value);
		my_fault.appendChild(my_faultcode);
		my_fault.appendChild(my_faultstring);
		my_fault.appendChild(my_detail);
		
		body.appendChild(my_fault);
		
		var stringy = new XMLSerializer().serializeToString(this.xmldom);
		
		this.body = this.xmldom.getElementsByTagName("env:Body")[0];
		
		this.header = this.xmldom.getElementsByTagName("env:Header")[0];
		
		this.envelope = this.xmldom.getElementsByTagName("env:Envelope")[0];
		
	},

	// PRIVATE METHODS

	SOAPEnvelope: function()
	{
		// PRIVATE FUNCTION
		try
		{
			
			var parser = new DOMParser();
			
			var doc = parser.parseFromString('<env:Envelope xmlns:env="http://schemas.xmlsoap.org/soap/envelope/" xmlns:enc="http://schemas.xmlsoap.org/soap/encoding/" env:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xs="http://www.w3.org/1999/XMLSchema" xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance"><env:Header></env:Header><env:Body></env:Body></env:Envelope>', "text/xml")
			
			this.e4x = doc;	
			
		} catch(e){alert(e)}
		return this.e4x;
	},

 	AJAXCall: function(soapcall_object, callback_function)
	{
		// PRIVATE FUNCTION

		var encodedXML = new XMLSerializer().serializeToString(soapcall_object.envelope);
		
		var parameter_uri = soapcall_object.transportURI;
		var parameter_object_uri = soapcall_object.actionURI;
		var parameter_method = soapcall_object.method;
		
		var var_http_method = "POST";
		var var_charset = 'UTF-8';
		
		// should receive an e4x object and a callback function, as well as url
		// should pass some error messages to the callback function so we know what happened
		// before sending it will serialize the e4x
		
		try {
		
		if (window.XMLHttpRequest) 
		{
			
			var request = new XMLHttpRequest();
			
			request.onreadystatechange = function()
			{
				//log('state='+request.readyState);
				
				//log('state=' + request.readyState + ' callback_function=' + callback_function);
				
				if (request.readyState == 4)
				{
					
					if (request.status == 404 && request.responseXML == null)
					{
						alert('404 - Not Found');
						callback_function.handleResponse(null, soapcall_object, 0);
					}
					else if (request.status == 401 && request.responseXML == null)
					{
						alert('401 - Unauthorized');
						callback_function.handleResponse(null, soapcall_object, 0);
					}
					else if (request.status == 500 && request.responseXML == null)
					{
//						alert('500 - Internal Server Error');
						callback_function.handleResponse(null, soapcall_object, 0);
					}
					else if (request.status == 500 && request.responseXML == null)
					{
//						alert('502 - Bad Gateway');
						callback_function.handleResponse(null, soapcall_object, 0);
					}
					else if (request.status == 503 && request.responseXML == null)
					{
//						alert('503 - Service Unavailable');
						callback_function.handleResponse(null, soapcall_object, 0);
					}
					else if (request.status == 504 && request.responseXML == null)
					{
//						alert('504 - Gateway Timeout');
						callback_function.handleResponse(null, soapcall_object, 0);
					}
					else if (request.status == 0 && request.responseXML == null)
					{
						alert('Can\'t connect to domain ' + parameter_uri);
						callback_function.handleResponse(null, soapcall_object, 0);
					}
					else if (request.status == 200 || request.status == 404)
					{
						// call callback function and pass myself and request to it
						var response = new soapy.SOAPResponse(request.responseXML);
						if (typeof(callback_function.handleResponse) == 'function')
						{
							callback_function.handleResponse(response, soapcall_object, 0);
						}
						else
						{
							callback_function(response, soapcall_object, 0);
						}
					}	
					else
					{
						// something bad happened
						
						if (request.status == 0)
						{
							var statustext = "Could not connect to host!";
						}
						else
						{
							var statustext = request.statusText;
						}
						
						// generate a SOAPFault element
						var response_xml = new soapy.SOAPFault(request.status, statustext);
						
						// pass the response object to the callback function as usual
						
						if (typeof(callback_function.handleResponse) == 'function')
						{
							callback_function.handleResponse(response_xml, soapcall_object, 0);
						}
						else
						{
							callback_function(response_xml, soapcall_object, 0);
						}
						
						
						return false;
					}
					
				}
			}
			
			
			request.open(var_http_method, parameter_uri, true);
			
 			request.setRequestHeader('Content-Type','text/xml; charset=' + var_charset);
			request.setRequestHeader('SOAPAction', parameter_object_uri + '/' + parameter_method);

			//log("SOAP REQUEST: \n" + encodedXML);
			request.send(encodedXML);
			
			
		}
		
		} catch(e){alert(e)}
	}

}


/*
	
	Request Handler
	
*/

//log('transport_URI='+transport_URI);

function SOAPh()
{}

// Request identificator string
SOAPh.prototype.var_id = "default";

//Request timeout threshold - milliseconds
SOAPh.prototype.var_timeout = 120000;

SOAPh.prototype.var_soapVersion  = 0; // Version 1.1
SOAPh.prototype.var_object       = "uri:XULadmin";
SOAPh.prototype.var_transport_URI = "http://example.tld/rpc/";

try
{
	if ( window.arguments[0] && window.arguments[0].transport_URI )
	{
		SOAPh.prototype.var_transport_URI = window.arguments[0].transport_URI.keyValue;
	}
}catch(e){
//alert(e)
}

log('transport_URI='+SOAPh.prototype.var_transport_URI);

//SOAP calls pool
SOAPh.prototype.obj_requestPool = {};

//request-unique ordinal counter
SOAPh.prototype.var_requestOrdinal = 0;

//tracks the count of requests in progress
SOAPh.prototype.var_requestCount = 0;

//creates a new SOAP call, adds it to request pool and returns its handle
SOAPh.prototype.fnc_requestAdd = function()
{
	var tmpOrdinal = ++this.var_requestOrdinal;

	if (typeof(SOAPCall) == 'function') 
	{
		this.obj_requestPool['request'+tmpOrdinal] = new SOAPCall();
	} else 
	{
		this.obj_requestPool['request'+tmpOrdinal] = new soapy.SOAPCall();
	}

	var_requestCount++;
	log('['+this.var_id+'] call #' + tmpOrdinal + ' added to pool (' + var_requestCount + ' active)');
	
	if (document.getElementById('statusbar-icon'))
	{
		if (var_requestCount > 0)
		{
			window.setCursor('wait')
			document.getElementById('statusbar-icon').setAttribute('class','busy');
		}
		else
		{
			window.setCursor('auto')
			document.getElementById('statusbar-icon').setAttribute('class','ready');
		}
	}
	if (document.getElementById('statusbar-progress'))
	{
		if (var_requestCount > 1)
		{
			document.getElementById('statusbar-progress').setAttribute('collapsed', 'false');
		}
		document.getElementById('statusbar-progress').setAttribute('value', (var_requestCount * 10));
	}
	
	return {
		call: this.obj_requestPool['request'+tmpOrdinal],
		ordinal: tmpOrdinal
	};
},

//removes a finished SOAP call from request pool
SOAPh.prototype.fnc_requestDelete = function(SOAPRequestOrdinal)
{
	delete this.obj_requestPool['request'+SOAPRequestOrdinal];
	var_requestCount--;
	log('['+this.var_id+'] call #' + SOAPRequestOrdinal + ' removed from pool (' + var_requestCount + ' active)');
	
	if (document.getElementById('statusbar-icon'))
	{
		if (var_requestCount > 0)
		{
			window.setCursor('wait')
			document.getElementById('statusbar-icon').setAttribute('class','busy');
		}
		else
		{
			window.setCursor('auto')
			document.getElementById('statusbar-icon').setAttribute('class','ready');
		}
	}
	if (document.getElementById('statusbar-progress'))
	{
		document.getElementById('statusbar-progress').setAttribute('value', (var_requestCount * 10));
		if (var_requestCount < 1)
		{
			document.getElementById('statusbar-progress').setAttribute('collapsed', 'true');
		}
	}
	
	return true;
}

SOAPh.prototype.fnc_create = function (method_name, args)
{
	var handler = this;
	try
	{
		log('['+handler.var_id+'] SOAP fnc_create');
		
		if (method_name==''){method_name = 'default';}
		
		var headers = new Array();
		
		var params  = new Array();
		
		for (var item in args)
		{
			if
			(
				(typeof(args[item])=="string")
				|| (typeof(args[item])=="number")
				|| (typeof(args[item])=="xml")
			)
			{
				if (typeof(SOAPCall) == 'function') 
				{
					params.push(new SOAPParameter(args[item],item));
				} else
				{
					params.push(new soapy.SOAPParameter(args[item],item));
				}
			}
		}
		
		var tmpRequest = this.fnc_requestAdd();
		var tmpCall = tmpRequest.call;
		var tmpOrdinal = tmpRequest.ordinal;

		
		tmpCall.transportURI = handler.var_transport_URI;
		
		tmpCall.actionURI = handler.var_object + "/" + method_name;
		
		tmpCall.encode(
			handler.var_soapVersion,
			method_name,
			handler.var_object,
			headers.length, headers,
			params.length, params
		);
		
		tmpCall.asyncInvoke(new gen_responseListener(this, tmpOrdinal));
		
		return null;
		
	}catch(e){alert('SOAP Error [fnc_init]: '+e)}
}


SOAPh.prototype.fnc_onResponse = function (header,body)
{
	log('['+this.var_id+'] SOAP fnc_onResponse >/dev/null');
}


/*
	
	Listener
	
*/


function gen_responseListener (parentObject, requestOrdinal)
{
	try
	{
		this.obj_parentObject = parentObject;
		this.var_requestOrdinal = requestOrdinal;
	}
	catch(e){alert(e)}
}


gen_responseListener.prototype.handleResponse =  function (resp, call, status)
{
	try
	{
		if (resp === null)
		{
		
			var e4x_header = new XML('<header></header>');
			var e4x_body = new XML('<body><response><method>'+call.method+'</method><result>0</result></response></body>');
			this.obj_parentObject.fnc_onResponse(e4x_header,e4x_body);
			return 1;
		}
		
		var xml_body_string = new XMLSerializer().serializeToString(resp.body);
		var xml_header_string = new XMLSerializer().serializeToString(resp.header);

		var e4x_header = new XML(new XMLSerializer().serializeToString(resp.header));		
		var e4x_body = new XML(new XMLSerializer().serializeToString(resp.body));

		var ENV = new Namespace('http://schemas.xmlsoap.org/soap/envelope/');
		
		log('['+this.obj_parentObject.var_id+'] SOAP fnc_response ' + e4x_header.request_code);
		
		if (e4x_body.ENV::Fault.length())
		{
			/* When SOAP service is broken */
			window.openDialog(
				'chrome://c3xuladmin/content/soap_error.xul',
				'cyclone-dialog',
				'chrome,centerscreen,modal,resizable',
				{
					'request_code': e4x_header.request_code.toString(),
					'method': e4x_header.method.toString(),
					'message': e4x_body..message.toString()
				}
			);	
		}
		else if (!e4x_body.response.length())
		{
			
			/* When SOAP response is okay, but not contain any correct Cyclone3 info */
			window.openDialog(
				'chrome://c3xuladmin/content/soap_unavailable.xul',
				'cyclone-dialog',
				'chrome,centerscreen,modal',
				{
					// this is not required, the target window does not display anything anyway
					//'header': e4x_header,
					//'body': e4x_body
				}
			);
			
			this.obj_parentObject.fnc_onResponse(e4x_header,e4x_body);
			
		}
		else if (e4x_body.response.@result != '1')
		{
			if (e4x_body.response.@type == 'login')
			{
				
				if (e4x_body.response.reason.match(/cookies are disabled/))
				{
					
					var my_domain = 'http://' + e4x_header.domain.toString() + '/';
					
					if (my_domain != call.transportURI)
					{	
						
						var e4x_header = new XML('<header><domain>'+ my_domain +'</domain></header>');
						var e4x_body = new XML("<body><response type=\"login\" reason=\"domain_change\"><method>"+call.method+"</method><result>0</result></response></body>");
						

					} else
					{
						
						alert(ui.locale.getStringFromName('window.login.cookies_disabled'));
					}

				} else
				{
					
					/* Display a nice login incorrect message */
					alert(ui.locale.getStringFromName('window.login.login_incorrect'));
				}
			}
			else if (e4x_body.response.@code == '301x01')
			{
				
				/* Display a nice permissions incorrect message */
//				alert(ui.locale.getStringFromName('301x01'));
				window.openDialog(
					'chrome://c3xuladmin/content/soap_alert.xul',
					'cyclone-dialog',
					'chrome,centerscreen,modal',
					{
						'request_code': e4x_header.request_code.toString(),
						'method': e4x_header.method.toString(),
						'reason': e4x_body.response.reason.toString()
					}
				);
			}
			else
			{
				/* When service has been not correctly executed */
				window.openDialog(
					'chrome://c3xuladmin/content/soap_alert.xul',
					'cyclone-dialog',
					'chrome,centerscreen,modal',
					{
						'request_code': e4x_header.request_code.toString(),
						'method': e4x_header.method.toString(),
						'reason': e4x_body.response.reason.toString()
					}
				);
//				this.obj_parentObject.fnc_onResponse(e4x_header,e4x_body);
			}
			
			this.obj_parentObject.fnc_onResponse(e4x_header,e4x_body);
		}
		else
		{
			this.obj_parentObject.fnc_onResponse(e4x_header,e4x_body);


			try{

				cyclone3xuladmin.gen_SOAPBroadcaster.fnc_broadcast(xml_header_string, xml_body_string);

			}catch(e)
			{
				// no broadcaster detected
				alert('no broadcaster detected' + "\n" + e);
			}
		}
		
		//alert('finish');
		return true;
		
		// Display confirmation
		// Part of content of SOAP message returned
		/*alert(resp.body.firstChild.firstChild.firstChild.data);*/
	
	}
	catch(e)
	{
		log('SOAP Error [fnc_response]: ' + e)
//		this.obj_parentObject.fnc_requestDelete(this.var_requestOrdinal)
	}
	finally
	{
		this.obj_parentObject.fnc_requestDelete(this.var_requestOrdinal)
	}
}

