var EXPORTED_SYMBOLS = ["cyclone3xuladmin", "log"];

var cyclone3xuladmin = {
	JXON:
	{
		JXONTree: function (oXMLParent) 
		{
			var nAttrLen = 0, nLength = 0, sCollectedTxt = "";
			if (oXMLParent.hasChildNodes()) 
			{
			for (var oNode, sProp, vContent, nItem = 0; nItem < oXMLParent.childNodes.length; nItem++) 
			{
				oNode = oXMLParent.childNodes.item(nItem);
				if ((oNode.nodeType - 1 | 1) === 3) 
				{ 
					sCollectedTxt += oNode.nodeType === 3 ? oNode.nodeValue.trim() : oNode.nodeValue; 
				} // nodeType is "Text" (3) or "CDATASection" (4)
				else if (oNode.nodeType === 1 && !oNode.prefix) 
				{ // nodeType is "Element" (1)
					//sProp = oNode.nodeName.toLowerCase();
					sProp = oNode.nodeName;
					vContent = new cyclone3xuladmin.JXON.JXONTree(oNode);
					if (this.hasOwnProperty(sProp)) 
					{
						if (this[sProp].constructor !== Array) 
						{ 
							this[sProp] = [this[sProp]]; 
						}
						this[sProp].push(vContent);
					} else 
					{ 
						this[sProp] = vContent; nLength++; 
					}
				}
			}
			this.keyValue = cyclone3xuladmin.JXON.parseText(sCollectedTxt);
			} else 
			{ 
					this.keyValue = null; 
			}
			if (oXMLParent.hasAttributes()) 
			{
				var oAttrib;
				this.keyAttributes = {};
				for (nAttrLen; nAttrLen < oXMLParent.attributes.length; nAttrLen++) 
				{
					oAttrib = oXMLParent.attributes.item(nAttrLen);
					this.keyAttributes[oAttrib.name.toLowerCase()] = cyclone3xuladmin.JXON.parseText(oAttrib.value.trim());
				}
			}
		},
	
		createXML: function (oObjTree) 
		{
			function loadObjTree (oParentEl, oParentObj) 
			{
				var vValue, oChild;
				if (oParentObj instanceof String || oParentObj instanceof Number || oParentObj instanceof Boolean) 
				{
					oParentEl.appendChild(oNewDoc.createTextNode(oParentObj.toString()));
				} else if (oParentObj.constructor === Date) 
				{
					oParentEl.appendChild(oNewDoc.createTextNode(oParentObj.toGMTString()));    
				}
	
				for (var sName in oParentObj) 
				{
					if (isFinite(sName)) { continue; } /* verbosity level is 0 */
					vValue = oParentObj[sName];
					if (sName === "keyValue") 
					{
						if (vValue !== null && vValue !== true) 
						{
							oParentEl.appendChild(oNewDoc.createTextNode(vValue.constructor === Date ? vValue.toGMTString() : String(vValue))); 
						}
					} else if (sName === "keyAttributes")
					{ 
						for (var sAttrib in vValue) 
						{
							oParentEl.setAttribute(sAttrib, vValue[sAttrib]); 
						}
					} else if (sName.charAt(0) === "@") 
					{
						oParentEl.setAttribute(sName.slice(1), vValue);
					} else if (vValue.constructor === Array) 
					{
						for (var nItem = 0; nItem < vValue.length; nItem++) 
						{
							oChild = oNewDoc.createElement(sName);
							loadObjTree(oChild, vValue[nItem]);
							oParentEl.appendChild(oChild);
						}
					} else 
					{
						oChild = oNewDoc.createElement(sName);
						if (vValue instanceof Object) 
						{
							loadObjTree(oChild, vValue);
						} else if (vValue !== null && vValue !== true) 
						{
							oChild.appendChild(oNewDoc.createTextNode(vValue.toString()));
						}
						oParentEl.appendChild(oChild);
					}
				}
			}
			const oNewDoc = document.implementation.createDocument("", "", null);
			loadObjTree(oNewDoc, oObjTree);
	
			return oNewDoc;
		},
	
		parseText: function (sValue) 
		{
			//if (/^\s*$/.test(sValue)) { return null; }
			//if (/^(?:true|false)$/i.test(sValue)) { return sValue.toLowerCase() === "true"; }
			//if (isFinite(sValue)) { return parseFloat(sValue); }
			//if (isFinite(Date.parse(sValue))) { return new Date(sValue); }
			return sValue;
		},
	
		convert_XML_JXON: function (xml_object)
		{
			var result_json = new cyclone3xuladmin.JXON.JXONTree(xml_object);
	
			return result_json;
		},
	
		convert_JXON_XML: function (json_object)
		{
			var result_xml = cyclone3xuladmin.JXON.createXML(json_object);
	
			return result_xml;
		}
	},
	getElementsWithAttribute: function(elRoot, elAttribute, objectPoll, processDepth)
	{
		if(!objectPoll)
		{
			objectPoll=new Array()
		}
		if (!processDepth)
		{
			processDepth=0;
		}
		processDepth++
		if (elRoot)
		{
			var nodelist=elRoot.childNodes;
			if (!nodelist.length)
			{
				try
				{
					nodelist=document.getAnonymousNodes(elRoot);
				}catch(e)
				{	
					return new Array();
				}
			}
			if(nodelist.length)
			{
				for(var i=0;i<nodelist.length;i++)
				{
					var currentChild=nodelist[i];
					
					try 
					{
						if(currentChild.getAttribute(elAttribute.name) == elAttribute.value)
						{
							objectPoll.push(currentChild)
						}
					}catch(e){
						// for some reason it ends here. now this should be researched further.
					}
	
					if(currentChild.childNodes.length)
					{
						var tmpReturn=getElementsWithAttribute(currentChild, elAttribute, objectPoll, processDepth)
						objectPoll=tmpReturn
					}
					else
					{
						continue
					}
				}
			}
		}
		return objectPoll
	},

	core: {

		log :
		{
	
			loglevel: 10,
	
			append : function (logText, log_level)
			{
				if (log_level)
				{
					if (log_level > this.loglevel) return;
				
				} else if (this.loglevel == 0) return;
							
				var aConsoleService = Components.classes["@mozilla.org/consoleservice;1"].
					getService(Components.interfaces.nsIConsoleService);
				aConsoleService.logStringMessage(logText);
			},
	
			getPreferredLogLevel : function ()
			{	
				var prefs = Components
					.classes["@mozilla.org/preferences-service;1"] 
					.getService(Components.interfaces.nsIPrefService)
					.getBranch(const_Cyclone3XULAdminPrefsRoot);
				try 
				{
					var loglevel = prefs.getIntPref('logLevel');
				}catch(e)
				{
					prefs.setIntPref('logLevel',0);
					var loglevel = prefs.getIntPref('logLevel');
				}
				return loglevel;
			}
		}
	},

	gen_SOAPBroadcaster:
	{
		//broadcaster identificator string
		var_id: "window_broadcast",
		
		//SOAP listener pool
		obj_listenerPool: {},
		
		//unique listener ordinal
		var_listenerOrdinal: 0,
		
		//count of registered SOAP listeners
		var_listenerCount: 0,
		
		//broadcasts the response
		fnc_broadcast: function(rHeader, rBody)
		{
			if(this.var_listenerCount>0)
			{
				//alert('broadcasting! listeners: '+this.var_listenerCount);
				for each(listener in this.obj_listenerPool)
				{
					//alert(listener);
					listener.fnc_onBroadcast(rHeader, rBody);
				}
			}
		},

		fnc_listenerRegister: function(listeningObject)
		{
			var tmpOrdinal = ++this.var_listenerOrdinal;
			this.obj_listenerPool['listener'+tmpOrdinal] = listeningObject;
			this.var_listenerCount++;
			log('['+this.var_id+'] listener #' + tmpOrdinal + ' added to pool (' + this.var_listenerCount + ' active)');

			return {ordinal: tmpOrdinal};
		},

		fnc_listenerUnregister: function(listenerOrdinal)
		{
			delete this.obj_listenerPool['listener'+listenerOrdinal];
			this.var_listenerCount--;
			log('['+this.var_id+'] listener #' + listenerOrdinal + ' removed from pool (' + this.var_listenerCount + ' active)');

			return true;
		}
	}

};

var log = function(message, level)
{
	cyclone3xuladmin.core.log.append(message, level)
};


